Attribute VB_Name = "basRegister"
Option Explicit
Option Compare Text

Private Declare Function LoadLibraryRegister Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibraryRegister Lib "kernel32" Alias "FreeLibrary" (ByVal hLibModule As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetProcAddressRegister Lib "kernel32" Alias "GetProcAddress" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CreateThreadForRegister Lib "kernel32" Alias "CreateThread" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, ByVal lpparameter As Long, ByVal dwCreationFlags As Long, RegComThreadID As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal RegComThreadHandle As Long, lpExitCode As Long) As Long
Private Declare Sub ExitThread Lib "kernel32" (ByVal RegComExitThread As Long)

Private Const STATUS_WAIT_0 = &H0
Private Const WAIT_OBJECT_0 = ((STATUS_WAIT_0) + 0)

Public Enum RegisterState
    DllRegisterServer = 1
    DllUnRegisterServer = 2
End Enum

Public Function RegisterComponent(ByVal FileName, ByVal RegState As RegisterState) As String
               
    'This function will register or unregister any ActiveX DLL or OCX File.
    
    Dim RegComLoad
    Dim RegComProcAddress
    Dim RegComThreadID
    Dim RegComSuccess
    Dim RegComExitThread
    Dim RegComThreadHandle
    
    If FileName = vbNullString Then Exit Function
    
    RegComLoad = LoadLibraryRegister(FileName)
    If RegComLoad = 0 Then RegisterComponent = "File Could Not Be Loaded Into Memory Space": Exit Function
    
    Select Case RegState
        Case DllRegisterServer:   RegComProcAddress = GetProcAddressRegister(RegComLoad, "DllRegisterServer")
        Case DllUnRegisterServer: RegComProcAddress = GetProcAddressRegister(RegComLoad, "DllUnregisterServer")
    End Select
    
    If RegComProcAddress = 0 Then
        RegisterComponent = "Not A Valid ActiveX Component"
        If RegComLoad Then Call FreeLibraryRegister(RegComLoad)
        Exit Function
    Else
        RegComThreadHandle = CreateThreadForRegister(ByVal 0&, 0&, ByVal RegComProcAddress, ByVal 0&, 0&, RegComThreadID)
        If RegComThreadHandle Then
            RegComSuccess = (WaitForSingleObject(RegComThreadHandle, 10000) = WAIT_OBJECT_0)
            If Not RegComSuccess Then
               GetExitCodeThread RegComThreadHandle, RegComExitThread
               ExitThread RegComExitThread
               RegisterComponent = "ActiveX Component Registration Failed]"
               If RegComLoad Then FreeLibraryRegister RegComLoad
               Exit Function
            Else
                If RegState = DllRegisterServer Then
                    RegisterComponent = "ActiveX Component Registered Successfully"
                ElseIf RegState = DllUnRegisterServer Then
                    RegisterComponent = "ActiveX Component UnRegistered Successfully"
                End If
            End If
            CloseHandle RegComThreadHandle
            If RegComLoad Then FreeLibraryRegister RegComLoad
        End If
    End If
    
End Function

